=== debian/changelog ===
hypre (2.16.0-4) unstable; urgency=medium

  * Team upload.
  * fix handling of nocheck build option

 -- Drew Parsons <dparsons@debian.org>  Sat, 27 Jul 2019 00:15:05 +0800

hypre (2.16.0-3) unstable; urgency=medium

  * Team upload.
  * don't run build-time tests if the nocheck option has been
    specified in DEB_BUILD_OPTIONS
  * status

 -- Drew Parsons <dparsons@debian.org>  Fri, 26 Jul 2019 17:17:44 +0800

hypre (2.16.0-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.0

 -- Drew Parsons <dparsons@debian.org>  Sun, 14 Jul 2019 14:42:09 +0800

hypre (2.16.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - remove patches applied upstream:
      fix_race_condition_b99fe77.patch
      fix_race_condition_97cd175.patch
  * Update debian/watch to new upstream repo,
    https://github.com/hypre-space/hypre
  * Standards-Version: 4.3.0
  * debhelper compatibility level 12
  * debian patch bootstrap-path.patch adds path to ./update-release.sh
    in src/config/bootstrap

 -- Drew Parsons <dparsons@debian.org>  Sat, 13 Apr 2019 22:49:51 +0800
